% Copyright  2009 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.



function output=calculate_fit_coef(lot);

num_lots = length(lot);

num_wafers = 0;

for i_lot =1:num_lots
    
    num_lot_wafers = length(lot(i_lot).wafer);
    
    for i_wafer = 1:num_lot_wafers
        
        num_wafers = num_wafers+1;
        
        [p, x, y, d, f, r1, rw1]=fit_wafer_coef(lot(i_lot).wafer(i_wafer));
        
        [rs, r2, rw2]=fit_remain_slope(rw1);
        
        output.a (num_wafers) = p(1);
        output.b (num_wafers) = p(2);
        output.c (num_wafers) = p(3);
        output.d (num_wafers) = p(4);
        output.e (num_wafers) = p(5);
        output.f (num_wafers) = p(6);
        
        for i_chip = 1:length(rw2.chip)
	
	    within_chip_var_tmp(i_chip) = var(rw2.chip(i_chip).delay);
	
	end
	
	
	within_chip_var(num_wafers) = mean(within_chip_var_tmp);
	
        output.sx {num_wafers} = rs(:,1)';
        output.sy {num_wafers} = rs(:,2)';
        output.sr {num_wafers} = rs(:,3)';
        
        inter_chip_var (num_wafers)=var (rs(:,3));
	inter_chip_mean(num_wafers)=mean(rs(:,3));
	
    end
    
end

output.within_chip_var = mean(within_chip_var);
output.inter_chip_var  = mean(inter_chip_var );





