% Copyright  2009 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.



function output=calculate_var(lot);

num_lots=length(lot);

num_wafers=0;
num_chips=0;

for i_lot=1:num_lots
    
    num_lot_wafers=length(lot(i_lot).wafer);
    
    for i_wafer = 1:num_lot_wafers
    	
	num_wafers=num_wafers+1;
	
	num_wafer_chips = length(lot(i_lot).wafer(i_wafer).chip);
	
        for i_chip = 1:num_wafer_chips
	    
            num_chips = num_chips+1;
	    
            lot(i_lot).wafer(i_wafer).inter_chip_delay(i_chip) = ...
                mean(lot(i_lot).wafer(i_wafer).chip(i_chip).delay);
	    
            lot(i_lot).wafer(i_wafer).chip(i_chip).within_chip_delay = ...
                lot(i_lot).wafer(i_wafer).chip(i_chip).delay - ...
                lot(i_lot).wafer(i_wafer).inter_chip_delay(i_chip);
	    
            lot(i_lot).wafer(i_wafer).within_chip_var (i_chip) = ...
                var (lot(i_lot).wafer(i_wafer).chip(i_chip).within_chip_delay);
	    
	    
        end
	
        lot(i_lot).wafer_within_chip_var (i_wafer)= ...
            mean(lot(i_lot).wafer(i_wafer).within_chip_var);
	
        lot(i_lot).wafer_inter_chip_var (i_wafer)= ...
            var (lot(i_lot).wafer(i_wafer).inter_chip_delay);
	
        lot(i_lot).inter_wafer_delay(i_wafer) = ...
            mean(lot(i_lot).wafer(i_wafer).inter_chip_delay(i_chip));    
    
    end
    
    lot_within_chip_var(i_lot) = mean (lot(i_lot).wafer_within_chip_var);
    lot_inter_chip_var (i_lot) = mean (lot(i_lot).wafer_inter_chip_var );
    lot_inter_wafer_var(i_lot) = var  (lot(i_lot).inter_wafer_delay     );
    
    inter_lot_delay (i_lot) = mean (lot(i_lot).inter_wafer_delay);

end

output.within_chip_var = mean(lot_within_chip_var);
output.inter_chip_var  = mean(lot_inter_chip_var );
output.inter_wafer_var = mean(lot_inter_wafer_var);
output.inter_lot_var   = var (inter_lot_delay     );

output.total_var 	= output.within_chip_var + output.inter_chip_var +...
    output.inter_wafer_var + output.inter_lot_var;

output.within_chip_var_ratio 	= output.within_chip_var / output.total_var;
output.inter_chip_var_ratio  	= output.inter_chip_var  / output.total_var;
output.inter_wafer_var_ratio 	= output.inter_wafer_var / output.total_var;
output.inter_lot_var_ratio      = output.inter_lot_var	 / output.total_var;

output.num_wafers=num_wafers;
output.num_chips =num_chips;



