function spc=extract_spc(lot, detail_var);

global within_chip_location_x within_chip_location_y 
global chip_size_x chip_size_y
global wafer_x_offset wafer_y_offset wafer_r


num_chips=0;

for i_lot = 1:length(lot)
    for i_wafer = 1:length(lot(i_lot).wafer)
        for i_chip = 1:length(lot(i_lot).wafer(i_wafer).chip)
	    
	    num_chips=num_chips+1;
	    
	    delay(i_chip,:)=lot(i_lot).wafer(i_wafer).chip(i_chip).delay;
	
	end
    end
end


num_locations=length(within_chip_location_x);

num_pairs=0;

for i_location=1:num_locations-1
    for j_location = i_location+1:num_locations
        
	num_pairs=num_pairs+1;
	
	dist(num_pairs)= sqrt(...
            (within_chip_location_x(i_location)- ...
             within_chip_location_x(j_location))^2+ ...
            (within_chip_location_y(i_location)- ...
             within_chip_location_y(j_location))^2);
        
	rho(num_pairs) = corr(delay(:,i_location), delay(:,j_location));

    end
end    


init_par=[0.5, 0.3, 1, 1];

lb = [0, 0, 0, 0];
ub = [1-detail_var.within_chip_var_ratio, detail_var.within_chip_var_ratio, inf, inf];


fit_par = lsqcurvefit(@spatial_function, init_par, dist, rho, lb, ub);


spc.inter_chip_var = fit_par(1)*detail_var.total_var;
spc.within_chip_spatial_var= fit_par(2)*detail_var.total_var;
spc.within_chip_random_var= (1-sum(fit_par(1:2)))*detail_var.total_var;
spc.spatial_par = fit_par(3:4);
