% Copyright  2009 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.



function [p, across_wafer_x, across_wafer_y, delay, fit_value, ...
    remain_value, remain_wafer]=fit_wafer_coef(wafer);

global within_chip_location_x within_chip_location_y 
global chip_size_x chip_size_y
global wafer_x_offset wafer_y_offset wafer_r

p=0;

num_chips = length(wafer.chip);
num_points = length(within_chip_location_x);

across_wafer_x = [];
across_wafer_y = [];

delay = [];

for i_chip=1:num_chips
    
    across_wafer_x = [across_wafer_x, ...
        wafer.chip(i_chip).chip_x * chip_size_x + within_chip_location_x];
    
    across_wafer_y = [across_wafer_y, ...
        wafer.chip(i_chip).chip_y * chip_size_y + within_chip_location_y];
    
    delay = [delay, wafer.chip(i_chip).delay'];
    
end

across_wafer_x = across_wafer_x - wafer_x_offset - wafer_r;
across_wafer_y = across_wafer_y - wafer_y_offset - wafer_r;

p=fit_quad_wafer_shape...
    (across_wafer_x, across_wafer_y, delay, @quad_function);

for i_chip=1:num_chips
    
    remain_wafer.chip(i_chip).chip_x = wafer.chip.chip_x;
    remain_wafer.chip(i_chip).chip_y = wafer.chip.chip_y;
    
    x_tmp = across_wafer_x((i_chip-1)*num_points+1:i_chip*num_points);
    y_tmp = across_wafer_y((i_chip-1)*num_points+1:i_chip*num_points);
    
    fit_value = quad_function(p, [x_tmp; y_tmp]);
    
    remain_wafer.chip(i_chip).delay = wafer.chip(i_chip).delay-fit_value';
        
end

fit_value = quad_function(p, [across_wafer_x; across_wafer_y]);

remain_value=delay - fit_value;

return;


