% Copyright  2009 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.



clc
clear all;


global within_chip_location_x within_chip_location_y 
global chip_size_x chip_size_y
global wafer_x_offset wafer_y_offset wafer_r


%%%%%%%%%%%%%% setting %%%%%%%%%%%%%%%%%%%%%

% within-chip locations of tested ring occilator

within_chip_location_x=...
    [0 0 0 0 1 1 1 2 2 2 3 3 3 3]*3+1.5;    
within_chip_location_y=...
    [0 3 6 9 2 5 8 1 4 7 0 3 6 9]+1.5;

% chip size

chip_size_x = 12;
chip_size_y = 12;

% value to set the origin to the center of the wafer

wafer_x_offset = chip_size_x * 2;
wafer_y_offset = chip_size_y * 1;

% wafer radius 

wafer_r = chip_size_x * 6  ;

% input data file

data_file = 'sample_data';

%%%%%%%%%%%%%% load data %%%%%%%%%%%%%%%%%%

disp('Loading data ...');

lot= read_data_line(data_file);

%%%%%%%%%%%%% calculate variance %%%%%%%%%%%%

disp('Calculating variation information ...');

detail_var = calculate_var(lot);


%%%%%%%%%%%%% calculate sptail corrrelation %%%%%%%%%%%%

spc=extract_spc(lot, detail_var);

%%%%%%%%%%%%%% calculate coefficients %%%%%%%%%%%

disp('Calculating fitting coefficients');

fit_coef = calculate_fit_coef(lot);


