% Copyright  2009 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.



function lot = read_data_line(file_name);

% file_name='t_data';

fid=fopen(file_name, 'r');

tline = fgets(fid);
tline = strrep(tline, 'lot_ID,wafer_ID,chipX,chipY', '');
tline = strrep(tline, ',', ' ');
tline = strrep(tline, 'psro_', ' ');
location = sscanf(tline, '%d ');
location_y=location-floor(location/10)*10;
location_x=floor((location-location_y)/10);

% location_x=location_x/max(location_x);
% location_y=location_x/max(location_y);
% 
% location_x_step = chip_size_x/max(location_x);
% location_y_step = chip_size_y/max(location_y);

num_chips=0;
previous_wafer_id=1;
chip_id=0;

while ~feof(fid)
    num_chips=num_chips+1;
    disp(['Loading data ', num2str(num_chips), ' chips']);
    tline=fgets(fid);   
    float_num=sscanf(tline, '%f,');
    lot_id   = float_num(1);
    wafer_id = float_num(2);
    chip_x   = float_num(3);
    chip_y   = float_num(4);
    data     = 1./float_num(5:length(float_num)); 
    
    if previous_wafer_id==wafer_id
    	chip_id=chip_id+1;
    else
    	chip_id=1;
    end	
    
    lot(lot_id).wafer(wafer_id).chip(chip_id).freq   = data;    
    lot(lot_id).wafer(wafer_id).chip(chip_id).delay  = 1./data;
    lot(lot_id).wafer(wafer_id).chip(chip_id).chip_x = chip_x;
    lot(lot_id).wafer(wafer_id).chip(chip_id).chip_y = chip_y;
    
    
    previous_wafer_id=wafer_id;
    
end

fclose(fid);
